---

- name: Create data directory if it does not exist
  ansible.builtin.file:
    path: "{{ minio_dir }}/data"
    state: directory
    recurse: true
  when: inventory_hostname in (minio_swarm_nodes if minio_swarm_nodes else groups.all)

- name: Startup minio in docker swarm
  when: inventory_hostname == groups[minio_master_group_name][0]
  block:
    - name: Create docker secrets for minio
      community.docker.docker_secret:
        name: "{{ item.0 }}"
        data: "{{ item.1 }}"
        state: present
      loop:
        - ['secret_key', "{{ minio_secret_key }}"]
        - ['access_key', "{{ minio_access_key }}"]

    - name: Make nodes list
      ansible.builtin.set_fact:
        minio_nodes: "{{ minio_swarm_nodes if minio_swarm_nodes else groups.all }}"

    - name: Copy minio-compose.yml to master
      ansible.builtin.template:
        src: minio-compose.yml.j2
        dest: "{{ minio_dir }}/minio-compose.yml"
        owner: root
        group: root
        mode: 0640

    - name: Deploy docker stack from a compose file
      community.docker.docker_stack:
        state: present
        name: minio-swarm
        compose:
          - "{{ minio_dir }}/minio-compose.yml"
